#import "QCAU.h"
#import "QCAUUI.h"
#import <Quartz/Quartz.h>
#include <CoreServices/CoreServices.h> 
#include <AudioUnit/AudioUnit.h>
#include <AudioToolbox/AudioToolbox.h> 
#import <CoreFoundation/CoreFoundation.h>
#import <Cocoa/Cocoa.h>
#import <AudioUnit/AudioUnitProperties.h>

@implementation QCAU : QCPatch

+ (int)executionModeWithIdentifier:(id)fp8
{
	return 2;
}
+ (int)executionMode
{
	return 2;
}

+ (BOOL)allowsSubpatchesWithIdentifier:(id)fp8
{
	return NO;
}
+ (BOOL)allowsSubpatches
{
	return NO;
}

+ (int)timeModeWithIdentifier:(id)fp8
{
	return 1;
}
+ (int)timeMode
{
	return 1;
}

/* If you don't want an inspector panel, simply comment out this function */
+ (Class)inspectorClassWithIdentifier:(id)fp8
{
	return [QCAUUI class];
}

- (id)initWithIdentifier:(id)fp8
{
	id z=[super initWithIdentifier:fp8];
	AudioComponentDescription au_description;
	AudioComponent audio_component;
	
	
	au_description.componentType         = 0;
	au_description.componentSubType      = 0;
	au_description.componentManufacturer = 0;
	au_description.componentFlags        = 0;
	au_description.componentFlagsMask    = 0;
	
	
	audio_component = AudioComponentFindNext (NULL,&au_description);
	
	AudioComponentDescription foundDescription;
	
	AudioComponentGetDescription (audio_component,&foundDescription);
	
	
	OSType type = CFSwapInt32HostToBig (foundDescription.componentType);
	OSType subtype = CFSwapInt32HostToBig (foundDescription.componentSubType);
	OSType manufacturer = CFSwapInt32HostToBig (foundDescription.componentManufacturer);
	
	
	while (audio_component != NULL) {
		
		AudioComponentGetDescription (audio_component,&foundDescription);
		
		type = CFSwapInt32HostToBig (foundDescription.componentType);
		subtype = CFSwapInt32HostToBig (foundDescription.componentSubType);
		manufacturer = CFSwapInt32HostToBig (foundDescription.componentManufacturer);
		
		NSLog (@"\t tID: %4.4s stID: %4.4s mID: %4.4s",
			   (char *) &type,
			   (char *) &subtype,
			   (char *) &manufacturer
			   );
		
		audio_component = AudioComponentFindNext (audio_component,&au_description);
	}
	
	
	
	
	// dynamic register from directory - register from specific component
	
	CFBundleRef mainBundleRef = NULL;
    CFURLRef    resourceURLRef = NULL;
	CFURLRef bundleURL = NULL;
    FSRef       resourceFSRef;
	CFAllocatorRef allocator=NULL;
	
	NSString* path;
	
	path = @"/Library/Audio/Plug-Ins/Components/";
	
	
	CFStringRef absPath;
	
	
	absPath = (CFStringRef)path;
	
	bundleURL =
    CFURLCreateWithFileSystemPath(NULL, absPath, kCFURLPOSIXPathStyle, TRUE);
	
	
	mainBundleRef = CFBundleCreate(allocator, bundleURL);
	
	
	
	
	CFArrayRef componentList;
	CFIndex listIndex;
	
	
	componentList = CFBundleCreateBundlesFromDirectory(allocator, bundleURL, CFSTR("component"));
	
	
	listIndex = CFArrayGetCount(componentList);
	NSLog(@"/Library/Audio/Plug-Ins/Components/ contains: %i audio units",listIndex);
	
	
	
	
	//register a specific component from path
	resourceURLRef = CFBundleCopyResourceURL(mainBundleRef,
											 CFSTR("Predator"),
											 CFSTR("component"), 0);
	
	
	if (NULL != resourceURLRef) {
		
		
		if (CFURLGetFSRef(resourceURLRef, &resourceFSRef) == true) {
			
			RegisterComponentFileRef(&resourceFSRef, true);
			
			
		}
		
		CFRelease(resourceURLRef);
		
	}
	
	

	return z;
}


- (id)setup:(QCOpenGLContext *)context
{


	return context;
}
- (void)cleanup:(QCOpenGLContext *)context
{


}


- (void)enable:(QCOpenGLContext *)context
{
	
		 
	

	
	

}
- (void)disable:(QCOpenGLContext *)context
{


}


- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{


	return YES;
}

@end
